tr46

An JavaScript implementation of Unicode Technical Standard #46: Unicode IDNA Compatibility Processing.

# Installation

Node.js ≥ 8 is required. To install, type this at the command line:

npm install tr46
# or
yarn add tr46

# API

## <tt>toASCII(domainName[, options])</tt>

Converts a string of Unicode symbols to a case-folded Punycode string of ASCII symbols.

Available options:

- `checkBidi`
- `checkHyphens`
- `checkJoiners`
- `processingOption`
- `useSTD3ASCIIRules`
- `verifyDNSLength`

## <tt>toUnicode(domainName[, options])</tt>

Converts a case-folded Punycode string of ASCII symbols to a string of Unicode symbols.

Available options:

- `checkBidi`
- `checkHyphens`
- `checkJoiners`
- `processingOption`
- `useSTD3ASCIIRules`

# Options

## <tt>checkBidi</tt>

Type: `Boolean`
Default value: `false`
When set to `true`, any bi-directional text within the input will be checked for validation.

## <tt>checkHyphens</tt>

Type: `Boolean`
Default value: `false`
When set to `true`, the positions of any hyphen characters within the input will be checked for validation.

## <tt>checkJoiners</tt>

Type: `Boolean`
Default value: `false`
When set to `true`, any word joiner characters within the input will be checked for validation.

## <tt>processingOption</tt>

Type: `String`
Default value: `"nontransitional"`
When set to `"transitional"`, symbols within the input will be validated according to the older IDNA2003 protocol. When set to `"nontransitional"`, the current IDNA2008 protocol will be used.

## <tt>useSTD3ASCIIRules</tt>

Type: `Boolean`
Default value: `false`
When set to `true`, input will be validated according to STD3 Rules.

## <tt>verifyDNSLength</tt>

Type: `Boolean`
Default value: `false`
When set to `true`, the length of each DNS label within the input will be checked for validation.